      program redcol
c=============================================================================c
c Calls the routine that calculates colour factors and writes a few
c declarations for the squared matrix element 'mpol2.f'
c=============================================================================c
 
      use rcolms

      implicit none

      integer :: ineq0
      character(10) :: ind,indp

      call colsqkk(ineq0)

      open(unit=30,file='colredx.f',status='replace',action='write')

      write(ind,'(i10)') ineq0
      write(indp,'(i10)') dp
      write(30,'(a)') '      integer, parameter :: iclr='
     &                                       //trim(adjustl(ind))
      write(30,'(a)') '      integer, dimension(iclr) :: ix,jx'
      write(30,'(a,d10.2)') '      real('//trim(adjustl(indp))//
     & '), parameter :: rcd=',1.d2*rcold
      write(30,'(a)') '      real('//trim(adjustl(indp))//
     & '), dimension(iclr) :: c2fd'

      close(30)

ckk>
c Calculates colour factors and eliminates equal raws in the color matrix
c      integer :: i,j,k,ieq,ieq0,eq(rdgs,2),col(rdgs)
c      character(80) :: ind1,ind2
c      real(dp) :: cfd2x
c      open(unit=13,status='scratch',access='direct',form='formatted',
c     &                                   action='readwrite',recl=22)

c      i=0
c 
c      do j=1,rdgs
c       do k=j,rdgs
c        i=i+1
c        read(13,'(e22.15)',rec=i) cfd2(j,k)
c       end do
c      end do

c      close(13)

c      do i=1,rdgs
c       do j=i,rdgs
c        if (abs(cfd2(i,j)) < rcold) cfd2(i,j)=0.d0
c       end do
c       do j=1,i-1
c        cfd2(i,j)=cfd2(j,i)
c       end do
c       col(i)=1
c      end do

c      ieq=0
c      ieq0=0

c      do i=2,rdgs
c       ieq0=ieq
c       do k=i-1,1,-1
c        do j=1,rdgs
c         if (cfd2(i,j) == 0.d0 .and. cfd2(k,j) == 0.d0) then
c          if (j == rdgs) then
c           write(*,*)'Equal rows:',i,' and',k
c           ieq=ieq+1
c           eq(ieq,:)=(/i,k/)
c           cfd2(i,:)=0.d0
c           cfd2(:,i)=0.d0
c           col(i)=0
c          end if
c         else if (abs((cfd2(i,j)-cfd2(k,j))/cfd2(k,j)) < rcold) then
c          if (j == rdgs) then
c           write(*,*)'Equal rows:',i,' and',k
c           ieq=ieq+1
c           eq(ieq,:)=(/i,k/)
c           cfd2(i,:)=0.d0
c           cfd2(:,i)=0.d0
c           col(i)=0
c          end if
c         else
c          exit
c         end if
c        end do
c        if (ieq > ieq0) exit
c       end do
c      end do

c      write(*,*)'There have been',ieq,' equal rows in the color matrix.'

c      open(unit=30,file='redcolm.f',status='replace',action='write')

c      do i=1,ieq
c       write(ind1,'(i16)') eq(i,1)
c       write(ind2,'(i16)') eq(i,2)
c       write(30,3010) trim(adjustl(ind2)),trim(adjustl(ind2)),
c     &                trim(adjustl(ind1))
c 3010  format('      mat(',a,')=mat(',a,')+mat(',a,')')
c       write(30,'(a)') '      mat('//trim(adjustl(ind1))
c     &                                    //')=(0.d0,0.d0)'
c      end do

c      close(30)

c      open(unit=30,file='colfacts.f',status='replace',action='write')

c      do i=1,rdgs
c       write(30,'(i2)') col(i)
c       do j=i,rdgs
c        write(30,'(e20.12)') cfd2(i,j)
c       end do
c      end do

c      close(30)

      end
